/*
 * (c) Copyright 2024 Walker Burgin. All rights reserved.
 */ "use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "Stylesheet", {
    enumerable: true,
    get: function() {
        return Stylesheet;
    }
});
var _linesandcolumns = require("lines-and-columns");
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
var Stylesheet = /*#__PURE__*/ function() {
    "use strict";
    function Stylesheet(source) {
        _class_call_check(this, Stylesheet);
        _define_property(this, "index", void 0);
        var stylesheet = new _linesandcolumns.LinesAndColumns(source);
        this.index = new Map(_to_consumable_array(source.matchAll(RegExp("\\.(?<className>[\\w-]+)\\s+{", "g"))).filter(function(match) {
            return match.index != null;
        }).map(function(match) {
            var _match_groups;
            var _stylesheet_locationForIndex;
            var location = (_stylesheet_locationForIndex = stylesheet.locationForIndex(match.index)) !== null && _stylesheet_locationForIndex !== void 0 ? _stylesheet_locationForIndex : undefined;
            if (location != null) {
                location.line = location.line + 1;
            }
            return [
                (_match_groups = match.groups) === null || _match_groups === void 0 ? void 0 : _match_groups.className,
                location
            ];
        }));
    }
    _create_class(Stylesheet, [
        {
            key: "findClass",
            value: function findClass(className) {
                return this.index.get(className);
            }
        }
    ]);
    return Stylesheet;
}();

//# sourceMappingURL=Stylesheet.js.map